Index: /extensions/Mail_supervisor/mail_super.inc.php
===================================================================
--- /extensions/Mail_supervisor/mail_super.inc.php	(revision 9702)
+++ /extensions/Mail_supervisor/mail_super.inc.php	(revision 9702)
@@ -0,0 +1,346 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based picture gallery                                  |
+// | Mail supervisor                                              |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010      cljosse                                        |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+if (!defined('MAIL_SUPERV_PATH'))
+define('MAIL_SUPERV_PATH', PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
+if (!defined('ROOT_URL'))
+define(  'ROOT_URL',  get_root_url().'/' );
+$MAIL_SUPERV_PATH_ABS=str_replace('\\','/',dirname(__FILE__) );
+if (!defined('MAIL_SUPERV_PATH_ABS'))
+define('MAIL_SUPERV_PATH_ABS',   $MAIL_SUPERV_PATH_ABS."/");
+
+class mail_supervisor {
+ //============================================================
+ /*
+  *  admin_menu
+ */
+ static public function admin_menu($menu) {
+  array_push($menu,
+             array( 'NAME' => 'Mail supervisor',
+                            'URL' => get_admin_plugin_menu_link(MAIL_SUPERV_PATH . 'admin/mail_superv_admin.php')
+                        )
+            );
+    return $menu;
+ }
+ //============================================================
+ /*
+  *  init
+ */
+ static public function init() {
+  global  $template,$version,$path_js,$icon_path;
+  if (PHPWG_VERSION < 2.2 ) {
+    $file =MAIL_SUPERV_PATH_ABS.'admin/header_2_1.tpl' ;
+    if (PHPWG_VERSION < 2.0 ) $path_js =  "template-common/lib/";
+    else $path_js=  'themes/default/js/' ;
+  } else {
+    $file =MAIL_SUPERV_PATH_ABS.'admin/header_2_2.tpl' ;
+    $path_js=  'themes/default/js/' ;
+  }
+  if(isset($_GET['action_spam']) and $_GET['action_spam']=="no"){
+    $action_spam = pwg_get_session_var('action_spam') ;
+    pwg_set_session_var('action_spam', "false");
+    unset ($_SESSION['pwg_'.'action_spam']);
+  }
+
+  $template->set_filenames(array('mail_superv_init'=> $file ));
+  if (file_exists ( 'admin/themes/clear/icon/help.png')) $icon_path = 'themes/default/icon/help.png';
+  else  $icon_path =  "admin/template/goto/theme/clear/icon/help.png";
+  $template->assign(
+      array('version' => $version,
+      'PHPWG_VERSION' =>     PHPWG_VERSION ,
+      'MAIL_SUPERV_PATH' =>  MAIL_SUPERV_PATH ,
+      'path_js' => $path_js,
+      'MAIL_SUPERV_PATH_ABS' => MAIL_SUPERV_PATH_ABS,
+      'action_spam' => pwg_get_session_var('action_spam')
+      )
+  );
+  $template->parse( 'mail_superv_init', false);
+
+  return ;//
+}// function init
+  //============================================================
+  /*
+  * affiche_message
+  */
+  //============================================================
+  static public function affiche_message(){
+    global $template,$infos_message,$erreur_message, $user ,$ip;
+    global $mails_options,$conf,$lang,$page ;
+    global $action_spam ;
+    if (!isset($ip)) {
+      if (getenv("HTTP_CLIENT_IP"))   {
+        $ip=getenv("HTTP_CLIENT_IP");
+      }else{
+          $ip=getenv("REMOTE_ADDR");
+      }
+    }    
+      //  unset ($_SESSION['pwg_'.'action_spam']);
+      $action_spam = pwg_get_session_var('action_spam') ;
+        
+      if  ($action_spam == null or $action_spam == 'false') {
+        $action_spam = kill_list();
+      }
+
+      if (is_bool($action_spam)) $action_spam =($action_spam == true) ? "true" : "false" ; 
+      if ($action_spam == "true" ) {
+        $erreur_message .= $ip . " "  . $action_spam  ;
+        pwg_set_session_var('action_spam', "true");
+        $erreur_message .= "<br />".l10n('Sv_is_a_spam') ;
+        if ($mails_options['no_connect'] == 'on1' ){
+                  //[status] => guest
+                  //[status] => normal
+                  //[status] => webmaster
+          if ($user['status'] != 'webmaster'  )
+            if (!isset($_GET['admin'])) {
+              die('Blacklist : <br />' .$erreur_message. '<br /> Hacking attempt!');
+            }elseif ($_GET['admin'] != 'piwigo'){
+              die('blacklist Hacking attempt!');
+            }
+         unset ($_SESSION['pwg_'.'action_spam']);
+      }
+    }else{
+      pwg_set_session_var('action_spam', "false");
+    }
+
+    if (isset($infos_message))
+      if  ($infos_message != "")  {
+        $infos_message = str_replace("\n",'<br />',$infos_message) ;
+        if(is_array($page['infos'])) array_push($page['infos'], $infos_message);
+        else $page['infos']=Array($infos_message);
+        $infos_message="";
+      }    
+    if (isset($erreur_message))
+      if  ($erreur_message != "")  {
+        $erreur_message = str_replace("\n",'<br />',$erreur_message) ;
+        if (!isset($page['errors'])) $page['errors']=Array($erreur_message);
+        if(is_array($page['errors'])) array_push($page['errors'], $erreur_message);
+        else $page['errors']=Array($erreur_message);
+        $erreur_message ="";
+      } 
+    return $action_spam;
+  } //fin Affiche_message
+
+    //============================================================
+  /*
+    *   Get_geo
+  */
+  static public function Get_geo() {
+    global  $info_geo,$ip,$pays,$region,$ville, $latitude ,$longitude,$mails_options;
+    //===================================================================================   
+    $info_geo = pwg_get_session_var('info_geo'); 
+    if (count($info_geo) > 0){
+        $pays  = $info_geo[0];
+        $region  = $info_geo[1];
+        $ville  = $info_geo[2];
+        $latitude = $info_geo[3];
+        $longitude = $info_geo[4];
+        $ip = $info_geo[5];
+        return true;
+    }
+    //=======================================================================
+    if (isset($_POST['pays'])) {
+      $pays = isset($_POST['pays']) ? $_POST['pays'] : "";
+      $region =  isset($_POST['region']) ? $_POST['region'] :"";
+      $ville = (isset($_POST['ville']))   ? $_POST['ville']: "";
+      $latitude =  isset($_POST['latitude']) ? $_POST['latitude'] : "";
+      $longitude =  isset($_POST['longitude']) ? $_POST['longitude'] : "";
+      $info_geo = array(   $pays ,$region , $ville ,$latitude, $longitude,$_SERVER['REMOTE_ADDR']  );
+      pwg_set_session_var('info_geo', $info_geo);
+        return true;
+      }else{
+
+     $result="";
+      echo '<script type="text/javascript">get_script_geo();</script>';
+   return true;
+      }
+    } // fin get_geo
+    //=====================================================================================
+    /*
+    * Memo_Var
+    */
+    static public function Memo_Var($variables) {
+    ob_start();
+    echo '<pre>';
+    foreach($variables as $key => $line){
+      echo  $key . " =>  " . $line ; 
+      echo "<br />";
+    }       
+    $m= ob_get_contents();
+    ob_end_clean();
+    return $m;
+    }
+  //======================================================================================
+   static public function Get_Version_plugins($dir){
+      $path = $dir;
+      $plg_data = implode( '', file($path.'main.inc.php') );
+      if ( preg_match("|Plugin Name: (.*)|", $plg_data, $val) )
+      {
+        $plugin['name'] = trim( $val[1] );
+      }
+      if (preg_match("|Version: (.*)|", $plg_data, $val))
+      {
+        $plugin['version'] = trim($val[1]);
+      }
+      if ( preg_match("|Plugin URI: (.*)|", $plg_data, $val) )
+      {
+        $plugin['uri'] = trim($val[1]);
+      }
+      if ($desc = load_language('description.txt', $path.'/', array('return' => true)))
+      {
+        $plugin['description'] = trim($desc);
+      }
+      elseif ( preg_match("|Description: (.*)|", $plg_data, $val) )
+      {
+        $plugin['description'] = trim($val[1]);
+      }
+      if ( preg_match("|Author: (.*)|", $plg_data, $val) )
+      {
+        $plugin['author'] = trim($val[1]);
+      }
+      if ( preg_match("|Author URI: (.*)|", $plg_data, $val) )
+      {
+        $plugin['author uri'] = trim($val[1]);
+      }
+      if (!empty($plugin['uri']) and strpos($plugin['uri'] , 'extension_view.php?eid='))
+      {
+        list( , $extension) = explode('extension_view.php?eid=', $plugin['uri']);
+        if (is_numeric($extension)) $plugin['extension'] = $extension;
+      }
+      // IMPORTANT SECURITY !
+      $plugin = array_map('htmlspecialchars', $plugin);
+      return $plugin ;
+    }
+  //==========================================================
+  function Get_Options($parametres,$str_index){
+    global $conf,$mails_options ;
+  $mails_options=  $conf[$str_index];
+ 
+ if(isset($mails_options))
+   if ( preg_match("|s:(.*)|", $mails_options, $val) )
+    $parametres =  unserialize($conf['mail_superv']);
+   else{
+     $parametres=explode(",",$mails_options);
+   
+    $def_para->check_mailto="on";
+    $def_para->check_header_carbon="on";
+    $def_para->check_header_text="on";
+    $def_para->no_mail_list="on";
+    $def_para->no_connect="on";	// empeche l'ip de se connecter au site.
+    $def_para->set_auto="on";		// Test a l'ouverture et enregistrement 
+    $def_para->ip="127.0.0.1";		// dernièrre adresse IP
+    $def_para->set_id="on";		  // enregistrment nouvel  
+    $i=0;
+    foreach ($def_para as $key => $value) {
+        $value=$parametres[$i];
+        unset( $parametres[$i]) ;
+        $parametres[$key]= $value  ; 
+        $i++;
+    }
+     }
+  return mail_supervisor::Set_Options($parametres,$str_index);
+  }	  
+  //==========================================================
+  function Set_Options($parametres,$str_index){  
+  global $infos_message,$conf;
+      foreach ($parametres as $key => $value) { 
+       $parametres[$key]=(isset($_POST[$key]))? "on" : $value ;
+     }
+   $parametres['no_connect']= 'off' ;     
+     return $parametres ;
+  }
+  //==========================================================
+function sauve_options(){
+global $options,$infos_message,$conf,$mails_options  ;
+$infos_message .=l10n("save_config")."<br>";
+ $mails_parametres=mail_supervisor::Set_Options($mails_options,"mail_superv");
+
+ if ( isset($mails_parametres) )
+ 	{		$query = '
+    		UPDATE '.CONFIG_TABLE.'
+    		SET value="'.addslashes(serialize($mails_parametres)).'"
+    		WHERE param = "mail_superv"
+    		LIMIT 1';
+ 			pwg_query($query);
+	  }
+	  
+ }
+
+  //=================================================================================
+  function sauve_donnees(){
+  global $mails_donnees,$superv_champs,$superv_type,$erreur_message ;
+  //=====================================================================	
+  $clefs = $superv_champs ;
+  $valeurs = array();
+  foreach ( $clefs as $champ){
+        $champ = trim($champ);     
+	    if ( isset($mails_donnees[  $champ ]) ) {
+	      $sep= (is_string($mails_donnees[ $champ ])) ? '"' : '' ;
+          array_push($valeurs , "`".$champ."`" . ' = ' . $sep . $mails_donnees[  $champ ] . $sep)  ;
+	    }else{	 
+	      array_push($valeurs , "`".$champ."`" . ' = ' .  "0"  )  ;
+	    }	 
+      }
+  $valeurs = implode(", ",$valeurs) ;
+  //=====================================================================
+  $query = '
+          UPDATE '.mail_superv_TABLE.'
+          SET '. $valeurs .'
+		  WHERE `id` = 1 LIMIT 1 ';
+		  ;
+  ob_start();
+  $ret=  pwg_query($query)    ;
+  $m= ob_get_contents();
+  ob_end_clean() ;
+  $erreur_message .= $m ;
+  }
+//=================================================================================
+  function Get_Datas(){
+    global $superv_champs ;
+    $champs = implode(",",$superv_champs );
+      $query = "SELECT ".$champs." 
+      FROM ".mail_superv_TABLE."
+      ;";
+		$result = @pwg_query($query); 
+    if (!$result) {
+			verif_base();
+	 		$result = @pwg_query($query);
+		}					
+    $data = mysql_fetch_array($result,MYSQL_ASSOC);
+    //====================================================================================
+    $next_day = Str_To_Time( $data['nb_mails_periode'], $data['date_mail'] ); 
+    $next_day = ($next_day >0) ? $next_day :  (604800  + time()) ; 
+    $data['rest_mail'] =    $next_day - time() ;
+    $next_day = Str_To_Time( $data['nb_spams_periode'],$data['date_spam']);
+    $next_day = ($next_day >0) ? $next_day :  (172800  + time()) ;
+    $data['rest_spam'] =  $next_day - time() ;
+    $next_day = Str_To_Time($data['quarantaine_periode'] ,$data['date_quarantaine']);	
+    $next_day = ($next_day >0) ? $next_day :  (172800 + time()) ;
+	
+    if ($data['quarantaine'] == 'true' ) {
+		    $data['reste'] =   ( $next_day )-time() ;
+    }else{
+		    $data['reste'] = 0;
+    }
+	
+	    return $data;
+  }
+ }
+?>
